COPYRIGHT Fujitsu Laboratories Ltd. 1993

DEPEM(1)		USER COMMANDS			DEPEM(1)

NAME
	depem - decrypt Internet Privacy Enhanced Mail

SYNOPSIS
	depem [-hvi][-f pem] -c cert -k key [-I issuer][-m mail] <pem > plain

DESCRIPTION

	Depem decrypts Privacy Enhanced Mail, RFC-1421, 1422, 1423 
	and 1424. The parameter "cert" and "key" are the recipient's
	certificate file and secret key.
	Depem takes input from either the standard input or 
	a file specified with the -f option. 

	The certificate file contains the public key, OSI distinguished
	name, expiration date, and serial number. 

	If the -i option is specified, depem examines the integrity of
	the PEM message. It checks three types of integrity: 
	- Whether the mail has been altered	
	- Whether the originator certificate is valid
	- Whether the issuer's certificate is valid.

OPTIONS
	-h	Help. Display help messages.

	-i	Integrity. Verify the signature and report the results 
		after displaying the decrypted message.

	-I	Issuer. Check that the issuer is the same as the
		the issuer specified by the subsequent certificate file.

	-k	Key. Specify the recipient's secret key file.

	-m	Mail. Check that the mail address is the same as that
 		stored in the sender's certificate. Typically, 
		the mail address is given in the From: field.

	-v	Verbose. Display debug information. 

EXAMPLES

	Decrypt a PEM file, file.pem, with secret key file, ~/.key:

		% depem -c ~/.cert -k ~/.key < file.pem

	where ~/.cert is the certificate file.

	Decrypt the PEM file, file.pem, with secrete key file, ~/.key, and
	verify the integrity of the message, recipient, and issuer:
	
		% depem -i -c ~/.cert -k ~/.key -I ~/.issuer < file.pem


	Verify that the mail address stored in file.pem is jun@wide.ad.jp:
	
		% depem -i -c ~/.cert -k ~/.key -m jun@wide.ad.jp < file.pem

	Warning messages output may indicates that mail is being sent by
	an intruder pretending to be jun@wide.ad.jp.

FILES
	.key .cert .issuer

SEE ALSO
	enpem(1), sendpem(1), pemcrypt(1)

AUTHOR
	Hiroaki Kikuchi (kikn@flab.fujitsu.co.jp)

