COPYRIGHT Fujitsu Laboratories Ltd. 1993

ENPEM(1)		USER COMMANDS			ENPEM(1)

NAME
	enpem - encrypt a file in Internet Privacy Enhanced Mail format

SYNOPSIS
	enpem [-evC][-f file] -c cert -k key -i issuer [user1 user2 ... ]
		<plain > pem 

DESCRIPTION

	Enpem encrypts a plaintext file in Internet Privacy Enhanced Mail 
	format,	defined by RFC-1421, 1422, 1423 and 1424. 
	The parameters "cert", "key", and "issuer" are the sender's 
	certificate file, the secret key, and the issuer's certificate file.
	Enpem takes input from either	the standard input or
	a file specified with the -f option. 

	Recipients are specified with the names of certificate files,
	"user1, user2, etc.," which contain the public key, OSI
	distinguished name, expiration date, and serial number.
	User certificates are usually stored in the certificate directory
	 ~/.certs.

	Enpem encrypts a message using DES in CBC mode, and signs
	using the MD5 message digest, defined in RFC-1321, and
	512-bits RSA public key encryption.

OPTIONS
	-e	Encrypt. Specify ENCRYPTED mode. The input message is 
		encrypted with the recipient's public key contained in 
		the certificate and signed with the sender's secret key
		 specified by -k option.  This is the default mode.

	-c	Certificate. Specify the certificate file which contains
		the sender's public key and the serial number.

	-C	Clear. Specify MIC-CLEAR mode. The input message is signed 
		with the sender's secret key. The message is not encrypted
		and can be read by anyone with a standard mail 
		program. 

	-h 	Help. Display help messages.

	-i	Issuer. Specify the certificate file of the issuer
		who certified the sender.

	-k	Key. Specify the sender's secret key file.

	-m	MIC. Same as -C option.

	-v	Verbose. Display debug information. 

EXAMPLES

	Encrypt the plaintext file, file.txt, with the recipient's 
	certificate, ~/.certs/jun@wide.ad.jp, and sign with the
	secret key, ~/.key:

		% enpem -e -c ~/.cert -k ~/.key -i ~/.issuer
			 ~/.certs/jun@wide.ad.jp < file.txt

	where ~/.cert and ~/.issuer are the recipient's and issuer's
	certificate files.

	Sign a plaintext file, file.txt, with your secret key:
	
		% enpem -C -c ~/.cert -k ~/.key -i ~/.issuer -f file.txt

	This is used when the recipient has no facility to decrypt 
	messages.

FILES
	.key .cert .issuer

SEE ALSO
	depem(1), sendpem(1), pemcrypt(1)

AUTHOR
	Hiroaki Kikuchi (kikn@flab.fujitsu.co.jp)

