COPYRIGHT Fujitsu Laboratories Ltd. 1993

SENDPEM(1)		USER COMMANDS			SENDPEM(1)

NAME
	sendpem, recvpem - simple Privacy Enhanced Mail filter

SYNOPSIS
	sendpem < plain > pem

	recvpem < pem > plain

DESCRIPTION

	sendpem is a simple Privacy Enhanced Mail filter, used just 
	before a mail item is passed to sendmail. It uses the same input 
	format as sendmail. It determines the recipient from the header
	and invokes enpem with the appropriate parameters.

	If the mail contains X-Pem: control field of ``MIC-CLEAR,''
	sendpem invokes enpem with the -C option specified, that is,
	enpem signs the message only.
	If the mail contains X-Pem: control field of ``ENCRYPTED,''
	sendpem invokes enpem with the -e option specified, that is, 
	enpem both encrypts and signs the message.
	If no corresponding certificate is found in the certificate 
	directory, sendpem is forced to use MIC-CLEAR.

	recvpem is used to decrypt and verify a pem message. 
	When the pem message is transferred from the sender the first time,
	recvpem puts the certificate into the directory.

	sendpem and recvpem use the user's secret key and certificate 
	at the locations specified when making it. 
	The default is as follows:

		$HOME/.key 		Your secret key
		$HOME/.cert 		Your certificate
		$HOME/.certs		User certificate directory
		$HOME/.issuer		Your issuer's certificate

	The above files are specified by the following environment
	variables:

		PEMKEY		Your secret 
		PEMCERT		Your certificate
		PEMCERTS	User certificate directory
		PEMISSUER	Your issuer's certificate


FILES
	.key .cert .certs .issuer

SEE ALSO
	enpem(1), depem(1), pemcrypt(1)

AUTHOR
	Hiroaki Kikuchi (kikn@flab.fujitsu.co.jp)

