/* osisec.h - internal to OSISEC */

#ifndef _OSISEC_PRIVATE_
#define _OSISEC_PRIVATE_

#include "config.h"
#ifndef OSISEC
#define OSISEC
#endif
#include "logger.h"
#include "quipu/ds_error.h"
#include "osisec/alg-access.h"
#include "osisec/serv-access.h"
#include "osisec/x509-concrete.h"

#define REVERSECPATH 0
#define FORWARDCPATH 1

/* Tailor file */

#define OSISECUSERTAILORFILE ".authrc"

/* Use thse macros to change the names of internal functions/variables */

#define USERNAME osisec_username
#define AUTHORITY osisec_authority
#define PASSWORD osisec_auth_passwd
#define MYCERTIFICATEFILE osisec_my_certificatefile
#define MYCERTIFICATE osisec_my_certificate

extern DN USERNAME;
extern char* PASSWORD;
extern DN AUTHORITY;
extern char *MYCERTIFICATEFILE;
extern struct certificate *MYCERTIFICATE;

#define KEYINFO2PUBKEY 	osisec_keyinfo2pubkey
extern int KEYINFO2PUBKEY();

#define CHECKCERTIFICATEPATHWITHPARMS 	osisec_check_cert_path_with_parms
extern int	CHECKCERTIFICATEPATHWITHPARMS();

/* Random number management */

#define RANDOMNNUMBER 	osisec_ASrand
#define SEED 		osisec_ASsrand
extern int	SEED();
extern int	RANDOMNNUMBER();

/* Time-stamping */

#define NEXTPERIOD 	osisec_next_period
#define CURRENTTIME 	osisec_curr_time
extern char *	CURRENTTIME();
extern char *	NEXTPERIOD ();

/* Variables */

extern struct certificate_list *MAKECERTIFICATEPATH();

/* Log file */

extern LLog *	log_osisec;

#endif /* _OSISEC_PRIVATE_ */
