/* testgen.c - validate the RSA routines for generating key parameters */

#include <stdio.h>
#include <sys/types.h>
#include <sys/time.h>

#include "osisec/numalgs.h"

#define MSH 15
#define MSL 31
#define SHORT 17
#define LONG  33

#define NPRIMES 6600

/* In fact, there are 6594 primes in the sieve */

main()
{
	unsigned        p[SHORT];
	unsigned        q[SHORT];
	unsigned        n[LONG];
	unsigned        d[LONG];
	unsigned        e[LONG];
	unsigned        a[LONG];
	unsigned        x[SHORT];
	unsigned        y[SHORT];
	unsigned        z[SHORT];
	unsigned        sieve[NPRIMES];
	FILE           *f1;
	int             i;
	unsigned       *ptr;
	int             r_shift;
	time_t		time();
	void		exit();

	f1 = fopen("../../support/sieve", "r");
	if (f1 == NULL) {
		(void)fprintf(stderr, "Can't open ../../support/sieve\n");
		exit(1);
	}
	i = 1;
	ptr = sieve + 1;
	while ((i < NPRIMES) && fscanf(f1, " %x", ptr) == 1)
		i++, ptr++;

#ifdef DEBUG
	(void)fprintf(stderr, "%d primes in sieve.\n", i - 1);
#endif

	sieve[0] = i - 1;
	(void)fclose(f1);

	f1 = stdout;

	(void)srandom((int)time((time_t*)0));
	r_shift = 0;
	strongprime(p, MSH, r_shift, z, MSH - 2, 0, sieve);
	bsr(p, p, MSH, r_shift);
	strongprime(q, MSH, 0, z, MSH - 2, 0, sieve);
	clear(d, MSL);
	d[0] = 1;
	d[1] = 1;
	(void)fflush(stdout);
	rsaparms(p, q, n, d, e, a, x, y, MSH, MSL);
	(void)fflush(stdout);
	(void)fprintf(f1, "L  = %d\n", (MSL+1)*16);
	(void)fprintf(f1, "P  = ");
	fhexdump(f1, p, MSH);
	(void)fprintf(f1, "Q  = ");
	fhexdump(f1, q, MSH);
	(void)fprintf(f1, "A  = ");
	fhexdump(f1, a, MSH);
	(void)fprintf(f1, "N  = ");
	fhexdump(f1, n, MSL);
	(void)fprintf(f1, "D  = ");
	fhexdump(f1, e, MSL);
	(void)fprintf(f1, "d1 = ");
	fhexdump(f1, x, MSH);
	(void)fprintf(f1, "d2 = ");
	fhexdump(f1, y, MSH);
	(void)fclose(f1);
	return 0;
}
