#!/bin/sh
#
# Script to test whether n newly Generated keys really work! 
#
set -x
n=100
while test "$1" != ""
do
	case $1 in
	-n)	n=$2; shift ;;
	-*)	echo "$prog: Unknown argument: $1" 1>&2; exit 1 ;;
	*)	case $# in
		0) : ;;
		*) echo "$prog: 0 parameters required ($*)" 1>&2; exit 1
		esac ;;
	esac
	shift
done
if test -d keys
then rm -rf keys/rsa\#*
else mkdir keys
fi
rsa_makekey -n $n -q $PWD/keys 2>/dev/null
good=0
bad=0
for i in `ls keys/rsa\#*`
do 
	rm -f rsakey
	ln $i rsakey
	if  testrsa 2>/dev/null 1>&2 
	then good=`expr $good + 1`
	else bad=`expr $bad + 1`
	fi
done
fname=keys/results
echo "#total=$n, good=$good, bad=$bad" >> $fname
echo "$n: $good: $bad: `date`" >> $fname
grep -v '#' $fname | \
	awk -F: '   {t += $1; g +=$2; b += $3} \
		 END{print "#Running Totals are:"
				print "#Total tested("t")";
				print "#Good("g")";
				print "#Bad("b")"
				print "#Proportion Bad is " b/t*100"%" }' $fname >> $fname

