;;; Fujitsu PEM user agent for mh-e
;;; Copyright (C) 1993 Fujitsu Laboratories Ltd.
;;; 	written  by Kenji Wakamiya (wkenji@flab.fujitsu.co.jp)
;;;	modified by Shinji Kobayashi (koba@flab.fujitsu.co.jp)
;;; $Id: pem-mhe.el,v 1.1 1994/02/25 10:31:30 kikn Exp kikn $

;; To encrypt
;; (setq mh-before-send-letter-hook '(lambda () (mh-pem-encrypt)))
;;   OR
;; (setq mh-letter-mode-hook
;;       '(lambda () (define-key mh-letter-mode-map "\ee" 'mh-pem-encrypt)))
;;
;; To decrypt
;; (setq mh-folder-mode-hook
;;       '(lambda () (define-key mh-folder-mode-map "\ed" 'mh-pem-decrypt)))

(defvar mh-pem-encrypt-command "sendpem")
(defvar mh-pem-decrypt-command "recvpem")

(defvar mh-pem-proctypes '(("ENCRYPTED") ("MIC-CLEAR")))

(defun mh-pem-encrypt ()
  (interactive "*")
  (save-excursion
    (let* ((completion-ignore-case t)
	(proctype (completing-read "X-Pem: "
				     mh-pem-proctypes
				     nil
				     'require-match)))
      (goto-char (point-min))
      (re-search-forward "^--------$" nil t)
      (replace-match "")
      (cond ((string= proctype "ENCRYPTED")
	     (insert "X-Pem: ENCRYPTED\n"))
	    ((string= proctype "MIC-CLEAR")
	     (insert "X-Pem: MIC-CLEAR\n")))
      (call-process-region (point-min) (point-max) mh-pem-encrypt-command t t)
      (goto-char (point-min))
      (re-search-forward "^$")
      (insert "--------"))))

(defun mh-pem-decrypt ()
  (interactive)
  (let ((showbuf mh-show-buffer))
    (pop-to-buffer mh-show-buffer)
;    (switch-to-buffer (get-buffer-create "*PEM Decrypt*"))
;    (erase-buffer)
;    (insert-buffer showbuf)
    (call-process-region (point-min) (point-max) mh-pem-decrypt-command t t)
    (goto-char (point-min))
    (other-window -1)))

(if (featurep 'mule)
    (progn
      (define-program-coding-system nil mh-pem-encrypt-command *junet*)
      (define-program-coding-system nil mh-pem-decrypt-command *junet*))
  (define-program-kanji-code nil mh-pem-encrypt-command 2)
  (define-program-kanji-code nil mh-pem-decrypt-command 2))
