;;; Fujitsu PEM user agent for RMAIL
;;; Copyright (C) 1994 Fujitsu Laboratories Ltd.
;;; 	written  by Kenji Wakamiya (wkenji@flab.fujitsu.co.jp)
;;;	modified by Shinji Kobayashi (koba@flab.fujitsu.co.jp)
;;; $Id$

;; Autoloads
;; (autoload 'rmail-pem-encrypt "pem-rmail" nil t)
;; (autoload 'rmail-pem-decrypt "pem-rmail" nil t)
;; (autoload 'rmail-pem-decrypt-and-save "pem-rmail" nil t)
;;
;; To encrypt
;; (setq mail-setup-hook
;;       '(lambda () (local-set-key "\ee" 'rmail-pem-encrypt)))
;;
;; To decrypt
;; (setq rmail-mode-hook
;;       '(lambda () (local-set-key "\ed" 'rmail-pem-decrypt)))
;;                   (local-set-key "\eD" 'rmail-pem-decrypt-and-save)))

(defvar rmail-pem-encrypt-command "sendpem")
(defvar rmail-pem-decrypt-command "recvpem")

(defvar rmail-pem-proctypes '(("ENCRYPTED") ("MIC-CLEAR")))

(defun rmail-pem-encrypt ()
  (interactive "*")
  (save-excursion
    (let* ((completion-ignore-case t)
	(proctype (completing-read "X-Pem: "
				     rmail-pem-proctypes
				     nil
				     'require-match)))
      (goto-char (point-min))
      (re-search-forward "^--text follows this line--$" nil t)
      (replace-match "")
      (cond ((string= proctype "ENCRYPTED")
	     (insert "X-Pem: ENCRYPTED\n"))
	    ((string= proctype "MIC-CLEAR")
	     (insert "X-Pem: MIC-CLEAR\n")))
      (call-process-region (point-min) (point-max) rmail-pem-encrypt-command t t)
      (goto-char (point-min))
      (re-search-forward "^$")
      (insert "--text follows this line--"))))

(defun rmail-pem-decrypt ()
  (interactive)
  (ding t)
  (message "Not supported yet."))

(defun rmail-pem-decrypt-and-save ()
  (interactive)
  (let ((buffer-read-only nil))
    (call-process-region (point-min) (point-max) rmail-pem-decrypt-command t t)
    (goto-char (point-min))
    (set-marker (aref rmail-message-vector (1+ rmail-current-message))
		(point-max))))

(cond ((featurep 'mule)
       (define-program-coding-system nil rmail-pem-encrypt-command *junet*)
       (define-program-coding-system nil rmail-pem-decrypt-command *junet*))
      ((boundp 'NEMACS)
       (define-program-kanji-code nil rmail-pem-encrypt-command 2)
       (define-program-kanji-code nil rmail-pem-decrypt-command 2)))
