;;; Fujitsu PEM user agent for VM
;;; Copyright (C) 1993 Fujitsu Laboratories Ltd.
;;; 	writen by Kenji Wakamiya (wkenji@flab.fujitsu.co.jp)
;;; $Id: pem-vm.el,v 1.1 1993/11/05 09:16:13 wkenji Exp $

;; To encrypt
;; (setq mail-setup-hook
;;       '(lambda () (define-key mail-mode-map "\ee" 'vm-pem-encrypt)))
;;
;; To decrypt (and save)
;; (setq vm-mode-hook
;;       '(lambda () (define-key vm-mode-map "\ed" 'vm-pem-decrypt)
;;                   (define-key vm-mode-map "\eD" 'vm-pem-decrypt-and-save)))

(setq sendmail-program "sendpemmail")
(defvar vm-pem-decrypt-command "recvpem")

(defvar vm-pem-proctypes '(("ENCRYPTED") ("MIC-CLEAR")))

(defun vm-pem-encrypt ()
  (interactive "*")
  (save-excursion
    (let ((proctype (completing-read "X-Pem: "
				     vm-pem-proctypes
				     nil
				     'require-match)))
      (goto-char (point-min))
      (re-search-forward
       (concat "^" (regexp-quote mail-header-separator)))
      (beginning-of-line)
      (cond ((string= proctype "ENCRYPTED")
	     (insert "X-Pem: ENCRYPTED\n"))
	    ((string= proctype "MIC-CLEAR")
	     (insert "X-Pem: MIC-CLEAR\n"))))))

(defun vm-pem-decrypt ()
  (interactive)
  (vm-follow-summary-cursor)
  (vm-error-if-folder-empty)
  (if vm-mail-buffer
      (select-window (get-buffer-window vm-mail-buffer)))
  (vm-edit-message)
  (rename-buffer "*PEM Decrypt*")
  (call-process-region (point-min) (point-max) vm-pem-decrypt-command t t)
  (goto-char (point-min)))

(defun vm-pem-decrypt-and-save ()
  (interactive)
  (vm-pem-decrypt)
  (vm-edit-message-end))

(if (featurep 'mule)
    (progn
      (define-program-coding-system nil sendmail-program *junet*)
      (define-program-coding-system nil vm-pem-decrypt-command *junet*))
  (define-program-kanji-code nil sendmail-program 2)
  (define-program-kanji-code nil vm-pem-decrypt-command 2))
