/* cerlib.c     COPYRIGHT Fujitsu Laboratories Ltd. 1993 */
/* $Id: cerlib.c,v 1.1 1995/03/08 06:04:26 kuroda Exp $ */
/* 	
 *	cerlib.c - Certificate processing	Aug. 26, 93/kikn
 */

#include	<stdio.h>
#include	<stdio.h>
#ifndef	_HAVE_NO_MALLOC_H_
#include	<malloc.h>
#endif
#include	"cert.h"
#include	"rsa.h"
#include	"pem.h"

char*
vfysig(cert, pub, parms)
BER	*cert;
struct RSAPublicKey	*pub;
struct RSAParameters	*parms;
{
	unsigned char	mic[BUFSIZ], buf[BUFSIZ], md[BUFSIZ];
	unsigned	rsain[BUFSIZ], *rsaout;
	BER	*alg, *info, *sig, *mdp, *mdv;
	int	i, j;

	bzero(rsain, sizeof rsain);
	info = C_IF(cert);
	enber(info, buf);

	alg = CDRS(C_S2(cert))[0];
	/* dispber(alg, "\n"); */

	if((bcmp(alg->val, OID[7], alg->len) == 0) ||
	   (bcmp(alg->val, OID[8], alg->len) == 0)){
		md2(mic, buf, info->byte);
	}else{
		return("Unknown AID (use MD2)");
	}
	/* for(i = 0; i < 16; ++i){
		printf("%.2x", mic[i]);
	}
	*/
	sig = C_SG(cert);
	if(sig->type != 03){
		return("Bad signature format");
	}
	for(i = sig->len -1, j = 0; i >= 0; i -= 2){
		rsain[j++] = sig->val[i] + (sig->val[i-1] << 8);
	}
	rsa_encrypt(rsain, &rsaout, pub, parms);
	/* fhexdump(stdout, rsaout, parms->len -1); */
	for(i = parms->len -1, j = 0; i >= 0; --i){
		buf[j++] = rsaout[i] >> 8;
		buf[j++] = rsaout[i] & 0xff;
	}
	if(verbose){
		printf("OUB buf:\n");
		for(i = 0; i < parms->len * 2; ++i){
			printf("%.2x", buf[i]);
		} printf("\n");
	}	
	padout(buf, md, 0x22 + 10); 
	if(md[0] != 0x30){
		return("Bad Encryption");
	}
	mdp = deber(md);
	if(verbose) dispber(mdp, "\n");
	mdv = CDRS(mdp)[1];

	return(bcmp(mic, mdv->val, 16)? "Invalid MIC": NULL);
}


BER*
readcert(name)
char	*name;
{
	static unsigned char	buf[BUFSIZ];
	FILE 	*fp;
	BER	*ber;

	if((fp = fopen(name, "r")) == NULL){
		fprintf(stderr, "Bad \"%s\" file\n", name);
		exit(1);
	}
	freadbyte(fp, buf, BUFSIZ);
	ber = deber(buf);
	fclose(fp);
	return(ber);
}

BER*
readpubkey(name, pub, parms)
char	*name;
struct RSAPublicKey	**pub;
struct RSAParameters	**parms;
{
	unsigned char	buf[BUFSIZ];
	FILE 	*fp;
	BER	*ber;

	if((*pub = (struct RSAPublicKey *)malloc(sizeof(**pub)))== NULL){
		perror("readpubkey");
		exit(1);
	}
	*parms = (struct RSAParameters *)malloc(sizeof(**parms));
	if((fp = fopen(name, "r")) == NULL){
		fprintf(stderr, "Bad \"%s\" file\n", name);
		exit(1);
	}
	freadbyte(fp, buf, BUFSIZ);
	ber = deber(buf);
	getpubkey(C_PK(ber), *pub, *parms);
	fclose(fp);
	return(ber);
}

