/* dedek.c     COPYRIGHT Fujitsu Laboratories Ltd. 1993 */
/* $Id: dedek.c,v 1.3 1995/03/16 12:08:42 kuroda Exp $ */
/*
***	getpem.c - decrypt message with a DEK	Nov 19, 20,92 /kikn
***			modified		Mar  8, 95/kuroda
 */

#include	<stdio.h>
#include 	"des.h"
#include 	"pem.h"
#include	"rsa.h"

#include	"MD/global.h"
#include	"MD/md5.h"

decmailmd5(dek, iv, md)
unsigned char	dek[], iv[], md[];
{
	static unsigned	char	buf[CBCSIZE+8];
	static unsigned	char	obuf[CBCSIZE+8];
	des_key_schedule 	ks;
	int	num;
	MD5_CTX	context;
	int	len;

	des_set_key(dek, ks);

	bzero(md, MICSIZE);
	MD5Init(&context);
	
	while(!prnfeof(fin)){
		num = freadbyte(fin, buf, CBCSIZE);
		des_cbc_encrypt(buf, obuf, (long)num, ks, iv, 0);
		if(num >= 8){
			bcopy(&buf[num-8], iv, 8);
		}
		if(prnfeof(fin)){
			num -= obuf[num-1];
		}
		MD5Update(&context, obuf, num);
		len = crlfl(obuf, buf, num);
		fwrite(buf, 1, len, fout); 
	}
	MD5Final(md, &context);
}

decmail(dek, iv)
unsigned char	dek[], iv[];
{
	static unsigned	char	buf[CBCSIZE+1000];
	static unsigned	char	obuf[CBCSIZE+1000];
	des_key_schedule 	ks;
	int	num, flag, rflag;
	int n;

	flag=1;
	rflag = 0;
	des_set_key(dek, ks);
	
	while(!prnfeof(fin)){
		num = freadbyte(fin, buf, CBCSIZE);
		des_cbc_encrypt(buf, obuf + rflag, (long)num, ks, iv, 0);
		num += rflag;
		rflag = 0;

		if(num >= 8){
			bcopy(&buf[num-8], iv, 8);
		}
		if(prnfeof(fin)){
			num -= obuf[num-1];
		}
		num = crlfl(obuf, buf, num);
		if(buf[num-1] == '\r'){
			rflag = 1;
			num--;
			obuf[0] = '\r';
		}
		fwrite(buf, 1, num, fout); 
	}
}

/*
prnfeof(fp)
FILE	*fp;
{
	int	c, c1;

	if(feof(fp)){ 
		return(1);
	}
	ungetc(c = fgetc(fp), fp);
	return(c == '-');

}

freadbyte(f, code, len)
FILE		*f;
unsigned char	code[];
int		len;
{
	static unsigned char	bin[COLBUF*2];
	static unsigned char	line[COLBUF*2];
	int     c, i, j;
	static int	binptr = 0, nbytes = 0;

	for(i = 0; i < len; ++i){
		if(binptr >= nbytes){
			if(prnfeof(f)){
				return(i);
			}
			if(fgets(line, COLBUF*2, f) == '\0'){
				return(i);
			}
			c = strlen(line);
			nbytes = prdecode(line, bin, (c-1)*6/8);
			binptr = 0;
		}
		code[i] = bin[binptr++];
	}
	return(len);
}
*/
