/* deklib.c     COPYRIGHT Fujitsu Laboratories Ltd. 1993 */
/* $Id: deklib.c,v 1.3 1995/03/09 12:07:14 kuroda Exp $ */
/*
***	dek.c - encrypt message with a DEK	Nov. 19,92 /kikn
***			modified		July 23,93 /kikn
***			modified		Mar. 2, 95 /kikn
***			modified		Mar. 8, 95 /kuroda
 */

#include	<stdio.h>
#include 	<sys/time.h>
#include 	"des.h"
#include 	"pem.h"

#include        "MD/global.h"
#include        "MD/md5.h"

encdes(in, out, len, dek, iv)
unsigned char	dek[], iv[];
unsigned char	in[], out[];
int		len;
{
	des_key_schedule 	ks;
	int	last, i;

	des_set_key(dek, ks);
	
	last = 8 - (len % 8);
	for(i = len; i < len + last; ++i){
		in[i] = last;
	}
	des_cbc_encrypt(in, out, (long)(len + last), ks, iv, 1);
	return(len + last);
}

dedes(in, out, len, dek, iv)
unsigned char	dek[], iv[];
unsigned char	in[], out[];
int		len;
{
	des_key_schedule	ks;

	des_set_key(dek, ks);

	des_cbc_encrypt(in, out, (long)len, ks, iv, 0);
	len -= out[len -1];
	return(len);
}


makedek(dek)
unsigned char	dek[];
{
	int	i, j, s;

	for(i = 0; i < DEKSIZE; ++i){
		dek[i] = random() & 0x7f;
		for(j = 0, s = 0; j < 7; ++j){
			s += (dek[i] >> j) & 1;
		}
		if(s & 1){
			dek[i] |= 0x80;
		}
	}
}

makeiv(iv)
unsigned char	iv[];
{
	int	i;

	for(i = 0; i < DEKSIZE; ++i){
		iv[i] = random() & 0xff;
	}
}

		
encmailmd5(dek, iv, md)
unsigned char	dek[], iv[], md[];
{
	static unsigned	char	buf[CBCSIZE*2+8], buf2[CBCSIZE+8];
	static unsigned	char	obuf[CBCSIZE*2+8];
	static unsigned	char	unbuf[BUFSIZ], unbuf2[BUFSIZ];
	des_key_schedule 	ks;
	int	num, last, r, i, u, u2, buf_flag;
	int n;
	MD5_CTX	context;

	last = u = r = 0;
	buf_flag = 1;

	des_set_key(dek, ks);
	bzero(md, MICSIZE);
	MD5Init(&context);
	
	while(buf_flag){
		if(!(num = fread(buf2, 1, CBCSIZE, fin))){
			buf_flag = 0;
		}
		bcopy(unbuf, buf, u);
		num = u + crlfn(buf2, buf + u, num);
		if(num >= 8 && !feof(fin)){
			u = num % 8;
			num = num - u;
			bcopy(&buf[num], unbuf, u);
		}
		MD5Update(&context, buf, num);
		if(feof(fin)){
			last = 8 - (num % 8);
			for(i = num; i < num + last; ++i){
				buf[i] = last;
			}
			num += last;
			MD5Final(md, &context);
			buf_flag = 0;
		}
		des_cbc_encrypt(buf, obuf, (long)num, ks, iv, 1);
		if(num >= 8){
			bcopy(&obuf[num-8], iv, 8);
		}
		writebyte(obuf, num);
	}
	writebyte(obuf, 0);
}

encmail(dek, iv)
unsigned char	dek[], iv[];
{
	static unsigned	char	buf[CBCSIZE+8];
	static unsigned	char	obuf[CBCSIZE+8];
	des_key_schedule 	ks;
	int	num, last, i;

	des_set_key(dek, ks);
	
	while(num = fread(buf, 1, CBCSIZE, fin)){
		if(feof(fin)){
			last = 8 - (num % 8);
			for(i = num; i < num + last; ++i){
				buf[i] = last;
			}
			num += last;
		}
		des_cbc_encrypt(buf, obuf, (long)num, ks, iv, 1);
		if(num >= 8){
			bcopy(&obuf[num-8], iv, 8);
		}
		/* fwrite(obuf, 1, num, fp); */
		writebyte(obuf, num);
	}
	writebyte(obuf, 0);

}

static char *prnline[] = {"%s\n", " %s\n", " %s\n" };
static char *prnend[]  = {"%s\n", " %s\n", " %s,\n" };
int	prntype = 0;

writebyte(code, len)
unsigned char 	code[];
int		len;
{
	static int	colptr = 0;
	static char	bin[COLBYTE], line[LINESIZE];
	int	i;

	if(len == 0 && colptr){
		prencode(bin, colptr, line);
		fprintf(fout, prnend[prntype], line);
		colptr = 0;
		return(0);
	}
	for(i = 0; i < len; ++i){
		bin[colptr++] = code[i];
		if(colptr >= COLBYTE){
			prencode(bin, COLBYTE, line);
			fprintf(fout, prnline[prntype], line);
			colptr = 0;
		}
	}
}

