/* epmlib.c     COPYRIGHT Fujitsu Laboratories Ltd. 1993 */
/* $Id: epmlib.c,v 1.1 1995/03/08 06:04:34 kuroda Exp $ */
/*
***	epmlib.c - encrypt PEM in ENCRYPTED mode, Sep. 1,93/kikn
 */

#include	<stdio.h>
#include	<sys/types.h>
#include	"pem.h"
#include	"cert.h"
#include	"rsa.h"

static char *pemtype[]={ "MIC-CLEAR", "ENCRYPTED", "MIC-ONLY" };

enpem(cert, mykey, myparms, users)
BER		*cert;
struct RSASecretKey	*mykey;
struct RSAParameters	*myparms;
BER	*users[];
{
	static unsigned char	dek[BUFSIZ], iv[BUFSIZ], user[BUFSIZ];
	static unsigned	char	md[BUFSIZ];
	static unsigned	char	iv2[BUFSIZ];
	BER	*sender, *issuer, *ca, *mdinfo;
	struct	RSAPublicKey	pub, mypub;
	struct	RSAParameters	parms, mypubparms;
	FILE	*ftmp;
	int	i, c;

	srandom((int)time(NULL) + getpid());
	makedek(dek);
	makeiv(iv);
	bcopy(iv, iv2, DEKSIZE);
	prntype = 1;

	fputs("-----BEGIN PRIVACY-ENHANCED MESSAGE-----\n", fout);
	fprintf(fout, "Proc-Type:4,%s\n", pemtype[encrypttype]);
	fputs("Content-Domain:RFC822\n", fout);
	fputs("DEK-Info: DES-CBC,", fout);
	for(i = 0; i < DEKSIZE; ++i){
		fprintf(fout, "%.2X", iv[i]);
	}
	fprintf(fout, "\nOriginator-Certificate:\n");
	cat(mycert);
	getpubkey(C_PK(cert), &mypub, &mypubparms);
	keyinfo(dek, &mypub, &mypubparms);  
	fprintf(fout, "Issuer-Certificate:\n");
	cat(issuercert);

	ftmp = tmpfile(); 
	SWAP(ftmp, fout);
	prntype = 0;
	encmailmd5(dek, iv, md);
	SWAP(ftmp, fout);
	prntype = 1;

	/* rsa_write_secret_key(mykey, "/dev/tty", myparms); */
	fputs("MIC-Info: RSA-MD5,RSA,\n", fout);
	putmic(md, dek, iv2, mykey, myparms);

	for(i = 0; users[i] != NULL; ++i){
		prntype = 2;
		printid(users[i]);
		prntype = 1;
		getpubkey(C_PK(users[i]), &pub, &parms);
		keyinfo(dek, &pub, &parms);
	}
	fputs("\n", fout);
	fseek(ftmp, 0L, 0);
	while((c = fgetc(ftmp)) != EOF){
		fputc(c, fout);
	}

	fclose(ftmp);
	fputs("-----END PRIVACY-ENHANCED MESSAGE-----\n", fout);
	return(0);
}
		
		
printid(ber)
BER	*ber;
{
	static unsigned char	buf[BUFSIZ];
	int	c, tmptype;

	fputs("Recipient-ID-Asymmetric:\n", fout);
	c = enber(C_IN(ber), buf);
	writebyte(buf, c);
	writebyte(buf, 0);
	fprintf(fout, " %x\n", SerialNumber(ber));
}


cat(f)
char *f;
{
	FILE *fp;
	int	c;

	/*
	fprintf(stderr, "FILE = %s (%s)\n", f, mycert);
	*/
	if((fp = fopen(f, "r")) == NULL){
		fprintf(stderr, "Bad \"%s\" file\n", f);
		exit(1);
	}
	while((c = fgetc(fp)) != EOF){
		fputc(c, fout);
	}
	fclose(fp);
}

