#!/bin/sh
# initcert.sh     COPYRIGHT Fujitsu Laboratories Ltd. 1993
# Nov. 17, 1993, kikn
# $Id: initcert.sh,v 1.4 1994/02/24 05:50:47 kikn Exp kikn $

pembin=STDLIBDIR

key=${PEMKEY-STDKEY}
cert=${PEMCERT-STDCERT}
issuer=${PEMISSUER-STDISSUER}
certdir=${PEMCERTS-STDCERTDIR}

if [ $# = 0 ]
then
	echo "usage: $0 responcemail"
	exit
fi
if [ -f "$issuer" -o -f "$cert" ]
then
	echo -n "WARNING: there exists $cert $issuer; overwrite ? (y/n) " 
	read a
	if [ "$a" != "y" ]
	then
		exit
	fi
fi
chmod 777 $cert $issuer
sed    -e "1,/^Originator/d" -e "/^Issuer/,$ d" $1 > $cert
sed -n -e "1,/^Issuer/d" -e "/^ /p" $1 > $issuer
chmod 400 $cert $issuer

test -d $certdir || mkdir $certdir
test -d $pembin/CERTS && cp -p $pembin/CERTS/* $certdir

email=`$pembin/peek -c < $cert | sed -n -e "/emailAddress/s/^.*=//p"`
ln -s $cert $certdir/$email
ln -s $issuer $certdir/ca@wide.ad.jp
