/* prnlib.c     COPYRIGHT Fujitsu Laboratories Ltd. 1993 */
/* $Id: prnlib.c,v 1.3 1995/03/16 12:09:22 kuroda Exp $ */
/*
***	prnlib.c - Printable encodeing read/write Aug. 6,93/kikn
***			modified		  Mar. 8,95/kuroda
 */

#include	<stdio.h>
#include	<string.h>
#include	"pem.h"

static int	binptr2 = 0, nbytes2 = 0;

freadcode(f, code, len)
FILE		*f;
unsigned 	code[];
int		len;
{
	static unsigned short	bin[COLBUF];
	static unsigned char	line[COLBUF];
	int	c, i, j;
	static int	binptr = 0, nbytes = 0;

	for(i = 0; i < len; ++i){
		if(binptr*2 >= nbytes){
			if(fgets(line, COLBUF, f) == '\0'){
				return(1);
			}
			c = strlen(line);
			nbytes = prdecode(line, bin, (c-1)*6/8);
			binptr = 0;
		}
		code[i] = MASK & bin[binptr++];
	}
	return(0);
}


prnfeof(fp)
FILE	*fp;
{
	int	c, c1;

	if(feof(fp)){ 
		return(1);
	}
	ungetc(c = fgetc(fp), fp);
	return(c == '-' && binptr2 >= nbytes2);
}

freadbyte(f, code, len)
FILE		*f;
unsigned char	code[];
int		len;
{
	static unsigned char	bin[COLBUF*2];
	static unsigned char	line[COLBUF*2];
	int     c, i, j;
/*	static int	binptr = 0, nbytes = 0;*/

	for(i = 0; i < len; ++i){
		if(binptr2 >= nbytes2){
			if(prnfeof(f)){
				return(i);
			}
			if(fgets(line, COLBUF*2, f) == '\0'){
				return(i);
			}
			c = strlen(line);
			nbytes2 = prdecode(line, bin, (c-1)*6/8);
			binptr2 = 0;
		}
		code[i] = bin[binptr2++];
	}
	return(len);
}

freadfield(f, field)
FILE		*f;
unsigned char	field[];
{
	static unsigned char	bin[BUFSIZ];
	static unsigned char	line[BUFSIZ];
	int     c, i, j;
	int	binptr = 0, nbytes = 0;
	char	*cp, *tp;

	while((cp = fgets(line, BUFSIZ, f)) != NULL && line[0] == ' '){
		c = strlen(line);
		/* if(verbose) printf("[%d]%s", c, line); */
		nbytes += prdecode(line, &field[nbytes], (c-1)*6/8);
		if(tp = strpbrk(line, "=,")){
			if(verbose){
				fprintf(stderr, "\tNo ungetc,(%d) \n", nbytes);
			}
			if(tp = strpbrk(tp, ",")){
				if(verbose) fprintf(stderr, "ungets(%s)\n", tp + 1);
				ungets(tp + 1);
			}
			return(nbytes);
		}
	}
	if(cp != NULL){
		ungets(line);
	}
	if(verbose) fprintf(stderr, "(%d)\n", nbytes);
	return(nbytes);
}
	
ungets(s)
char	s[];
{
	int	c;
	for(c = strlen(s) -1; c >= 0 ; --c){
		ungetc(s[c], fin);
	}
}

