/* rsalib.c     COPYRIGHT Fujitsu Laboratories Ltd. 1993 */
/* $Id: rsalib.c,v 1.1 1995/03/08 06:04:41 kuroda Exp $ */
/*
***	rsalib.c -	tools for RSA encryption, Aug. 30, 93/kikn
 */

#include	<stdio.h>
#include	"pem.h"
#include	"rsa.h"

nrsa_decrypt(in, out, key, parms)
unsigned char   in[], out[];
struct RSASecretKey     *key;
struct RSAParameters    *parms;
{
	static unsigned		w[BUFSIZ], *w2;
	static unsigned char	buf[BUFSIZ];

        char2word(in, w, parms->len * 2);
	if(verbose) fhexdump(stderr, w, parms->len -1);
        rsa_decrypt(w, &w2, key, parms);
	if(verbose) fhexdump(stderr, w2, parms->len -1);
        word2char(w2, out, parms->len);
}

char2word(c, w, csize)
unsigned char	c[];
unsigned int	w[];
int		csize;
{
	int	i, j;

	for(i = csize -1, j = 0; i >= 0; i -= 2){
		w[j++] = c[i] + (c[i-1] << 8);
	}
}

word2char(w, c, wsize)
unsigned int	w[];
unsigned char	c[];
int		wsize;
{
	int	i, j;

	for(i = wsize -1, j = 0; i >= 0; --i){
		c[j++] = w[i] >> 8;
		c[j++] = w[i] & 0xff;
	}
}

