#!STDPERL
# sendpem.pl     COPYRIGHT Fujitsu Laboratories Ltd. 1993
#		 Dec. 16, 1993,  kikn
# $Id: sendpem.pl,v 1.1 1995/03/08 06:05:15 kuroda Exp $

#$debug = 1;

$HOME = $ENV{'HOME'};
$mykey = $ENV{'PEMKEY'} || "STDKEY" ;
$mycert = $ENV{'PEMCERT'} || "STDCERT";
$certdir = $ENV{'PEMCERTS'} || "STDCERTDIR";
$myissuer = $ENV{'PEMISSUER'} || "STDISSUER";

$whoisd = $ENV{'PEMSERV'} || 'STDPEMSERV';
$dom    = $ENV{'PEMDOMAIN'} || 'STDPEMDOMAIN';

$bin = "STDLIBDIR";
$enpem = "$bin/enpem";

$| = 1;

if(@ARGV){
	$to = join(',',@ARGV);
	$proctype = '-e';
}else{
	while(<STDIN>){
		push(@header, $_);
		last if /^$/;
		if(/^X-Pem:\s*(\S*)$/i){
			$proctype = ($1 =~ /MIC-CLEAR/i)? '-m' : '-e';
		}elsif(/^(To|Cc|Apparently-To): (.*)$/i){
			$to .= $to ? ','.$2 : $2;
			$flag = 1;
		}elsif(/^\s+(.*)$/ && $flag){
			$to .= $1;
		}else{
			$flag = 0;
		}
	}
}
$to = '' if($proctype eq '-m');
$to =~ s/"[^"]*"//g;
for(split(',', $to)){
	tr/A-Z/a-z/;
	s/.*<(.*)>.*/$1/;
	s/\(.*\)//;
	s/\s*(\S*)\s*/$1/;
	if($dom){
		$_ = &canform($_);
	}
	print STDERR "USER($_)\n" if($debug);
	push(@user,$_);
}


unless($proctype){
	print @header;
	while(<STDIN>){
		print $_;
	}
	exit(0);
}
for $a (@user){
	$certdir = '/tmp' if ! -d $certdir;
	$users .= $users ? " $certdir/$a" : "$certdir/$a";
	print STDERR "USERS = $users\n" if($debug);
	if(-f "$certdir/$a"){
		$recip = "$certdir/$a";
	}elsif(!$whoisd){
		$proctype = '-C';
	}else{
		$a =~ s/\/([^\/]*)$/$1/;
		open(W, "whois -h $whoisd to:$a|") || die "whois: $!\n";
		@cer = <W>;
		close(W) || die "whois-got: $!\n";
		if($cer[0] =~ /^ERROR/){
			$proctype = '-C';
		}else{
			$recip = "$certdir/$a";
			open(C, ">$recip") || die "writing-cert: $!\n";
			print C @cer;
			close(C) || die "wrote-cert: $!\n";	
		}
	}
}

print @header; 
print STDERR "|$enpem $proctype -k $mykey
	-c $mycert -i $myissuer $users" if $debug;
open(E, "|$enpem $proctype -k $mykey -c $mycert -i $myissuer $users")
	|| die "enpem: $!\n";
while(<STDIN>){
	print E $_ || die "enpem-sending: $!\n";
}
close(E) || die "enpem-end: $!\n";
exit 0;

sub canform{
	local($_) = pop(@_);
	local(@a, $b);

	if(/@(.*)$/){
		@a = split('\.', $1);
		$b = pop( @a );
		if($dom =~ /$b/){
			return( $_.$' );
		}else{
			return($_);
		}
	}else{
		return( $_."@".$dom);
	}
}

