/* siglib.c     COPYRIGHT Fujitsu Laboratories Ltd. 1993 */
/* $Id: siglib.c,v 1.1 1995/03/08 06:04:42 kuroda Exp $ */
/* 	
 *	siglib.c - Sign on Certificate	Sep. 12, 93/kikn
 */

#include	<stdio.h>
#include	<stdio.h>
#ifndef	_HAVE_NO_MALLOC_H_
#include	<malloc.h>
#endif
#include	"cert.h"
#include	"rsa.h"
#include	"pem.h"

static	unsigned char	sigBER[] = {
	0x30, 0x20, 
	      0x30, 0x0c, 
		    0x06, 0x08, 
			  0x2a, 0x86, 0x48, 0x86, 0xf7, 0x0d, 0x02, 0x02, 
		    0x05, 0x00, 
	      0x04, 0x10, 
	      	    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 
};

char*
sign(cert, key, parms)
BER	*cert;
struct RSASecretKey	*key;
struct RSAParameters	*parms;
{
	unsigned char	mic[BUFSIZ], buf[BUFSIZ], bin[BUFSIZ];
	unsigned char	signedbin[BUFSIZ];
	BER	*alg, *info, *sigber, *certsig, *sig;
	int	i, j, c, minus;

	info = C_IF(cert);
	enber2(info, buf);

	alg = CDRS(C_S2(cert))[0];

	if((bcmp(alg->val, OID[7], alg->len) == 0) ||
	   (bcmp(alg->val, OID[8], alg->len) == 0)){
		md2(mic, buf, info->byte);
	}else{
		return("Unknown AID (use MD2)");
	}

	certsig = C_SG(cert);

	sigber = deber(sigBER);
	bcopy(mic, CDRS(sigber)[1]->val, MICSIZE);
	c = enber2(sigber, buf);

	pad(1, buf, c, bin, parms->len * 2);
	nrsa_decrypt(bin, signedbin, key, parms);
	
	sig = (BER *)malloc(sizeof(BER));
	sig->type = 03;
	minus = (signedbin[0] & 0x80)? 1 : 0;
	minus = 1;
	sig->len  = parms->len *2 + minus;
	sig->val  = (unsigned char*)calloc(sig->len, 1);
	sig->byte = ((sig->len > 0x7f)? 3 : 2 ) + sig->len;
	bcopy(signedbin, &(sig->val)[minus], parms->len *2); 
	C_SG(cert) = sig;

	cert->len = cert->len - certsig->len + sig->len;
	cert->byte = cert->byte - certsig->byte + sig->byte;
	/* printf("OUB buf:\n");
	for(i = 0; i < parms->len * 2; ++i){
		printf("%.2x", mic[i]);
	} printf("\n");
	*/
	return(NULL);
}

