/* testdpm.c     COPYRIGHT Fujitsu Laboratories Ltd. 1993 */
/* $Id: testdpm.c,v 1.1 1995/03/08 06:04:45 kuroda Exp $ */
/*
***	testdpm.c - test for decrypt PEM ENCRYPTED, Aug. 30, 93
 */

#include	<stdio.h>
#include	"pem.h"
#include	"cert.h"
#include	"rsa.h"

char	usage[]	= "usage: %s [-hvi] -c cert -k key [-I issuer][-m mail][-f pem]\n";

FILE	*fin = stdin;
FILE	*fout = stdout;
int	encrypttype = 0;
int	verbose = 0;
int	integrity = 0;
char	*mycert = NULL;
char	*issuercert = NULL;
char	*mymail = NULL;

main(argc, argv)
int argc;
char *argv[];
{
	unsigned char	buf[BUFSIZ];
	int	c, i;
	char	*mic;
	BER	*cert = NULL;
	extern char	*optarg;
	struct RSASecretKey	*key = NULL;
	struct RSAPublicKey	*pub;
	struct RSAParameters	*parms;

	while((c = getopt(argc, argv, "c:k:f:I:m:ihv")) != -1){
		switch(c){
		case 'm':
			mymail = optarg;
			break;
		case 'I':
			issuercert = optarg;
			break;
		case 'i':
			integrity = 1;
			break;
		case 'c':
			cert = readpubkey(optarg, &pub, &parms);
			break;
		case 'k':
			if(rsa_read_secret_key(optarg, &key, &parms)){
				fprintf(stderr, "bad \"%s\" secretkey\n", optarg);
				exit(1);
			}
			break;
		case 'f':
			if((fin = fopen(optarg, "r")) == NULL){
				fprintf(stderr, "No \"%s\" file\n", optarg);
				exit(1);
			}
			break;
		case 'v':
			verbose = 1;
			break;
		case 'h':
		default:
			fprintf(stderr, usage, argv[0]);
			exit(1);
		}
	}
	if(key == NULL){
		fprintf(stderr, usage, argv[0]);
		exit(1);
	}
	exit(depem(cert, key, parms));
}

