/* testepm.c     COPYRIGHT Fujitsu Laboratories Ltd. 1993 */
/* $Id: testepm.c,v 1.1 1995/03/08 06:04:46 kuroda Exp $ */
/*
***	testepm.c - test for encrypt PEM ENCRYPTED, Sep. 1, 93
 */

#include	<stdio.h>
#include	"pem.h"
#include	"cert.h"
#include	"rsa.h"

char	usage[]	= "usage: %s [-evC] -c user.cert -k user.key -i issuer.cert [-f file.txt] user1.cert user2.cert ...\n";

FILE	*fin = stdin;
FILE	*fout = stdout;
int	verbose = 0;
int	integrity = 0;
int	encrypttype = 1;
char	*mycert = NULL;
char	*issuercert = NULL;
char    *mymail = NULL;

main(argc, argv)
int argc;
char *argv[];
{
	unsigned char	buf[BUFSIZ];
	int	c, i;
	char	*mic;
	BER	*cert = NULL;
	BER	*users[100];
	extern char	*optarg;
	extern int	optind;

	struct RSASecretKey	*key = NULL;
	struct RSAPublicKey	*pub;
	struct RSAParameters	*parms;

	srandom((int)time(NULL) + getpid());

	while((c = getopt(argc, argv, "i:c:k:f:hvemC")) != -1){
		switch(c){
		case 'i':
			issuercert = optarg;
			break;
		case 'C':
		case 'm':
			encrypttype = 0;
			break;
		case 'e':
			encrypttype = 1;
			break;
		case 'c':
			mycert = optarg;
			cert = readpubkey(optarg, &pub, &parms);
			break;
		case 'k':
			if(rsa_read_secret_key(optarg, &key, &parms)){
				fprintf(stderr, "bad \"%s\" secretkey\n", optarg);
				exit(1);
			}
			break;
		case 'f':
			if((fin = fopen(optarg, "r")) == NULL){
				fprintf(stderr, "No \"%s\" file\n", optarg);
				exit(1);
			}
			break;
		case 'v':
			verbose = 1;
			break;
		case 'h':
		default:
			fprintf(stderr, usage, argv[0]);
			exit(1);
		}
	}
	if(key == NULL){
		fprintf(stderr, usage, argv[0]);
		exit(1);
	}
	if(!mycert && !issuercert){
		fprintf(stderr, "spcify -c and -i options\n");
		exit(1);
	}
	switch(encrypttype){
	case 0:
		micclear(cert, key, parms);
		break;
	case 1:
		for(i = 0; optind < argc; ++optind){
			users[i++] = readcert(argv[optind]);
		}
		users[i] = NULL;
		enpem(cert, key, parms, users);
	}
	exit(0);
}


